_agnia.providers['barclays'] = {
    "name": "barclays",
    "did": "did:agnia:A5801Dca074d63614F4A0D9e49CcEAEb7b77Fd72",
    "logo": "assets/img/barclays.svg",
    "check":
    {
        "name": "check",
        "form":
        {
            "url": baseUrl + "providers/barclays/check",
            "fields":
            [
                {
                    "label": "NIF",
                    "type": "text",
                    "name": "nif",
                    "mandatory": true,
                    "validator": "NIF",
                    "verified": true,
                    "data-type": "id"
                }
            ]
        }
    },

    "claims":
    [
    ],
    "i18n":
    {
        "en":
        {
            "barclays": "Barclays Bank",
            "barclays-name": "Name",
            "barclays-surname": "Surname",
            "barclays-nif": "NIF",
            "check": "Check bank accounts",
            "name": "Name",
            "surname": "Surname",
            "nif": "NIF",
            "account_claim": "Bank account claim",
            "account": "Bank account",
            "balance_claim": "Bank account balance",
            "balance": "Bank account balance",
            "date": "balance date",
            "average_balance": "Average balance last 12 months",
            "data-types": {
                "account_claim": "Bank account claim",
                "balance_claim": "Bank account balance"
            }
        },
        "es":
        {
            "barclays": "Barclays Bank",
            "barclays-name": "Nombre",
            "barclays-surname": "Apellidos",
            "barclays-nif": "NIF",
            "check": "Comprobar cuentas bancarias",
            "name": "Nombre",
            "surname": "Apellidos",
            "nif": "NIF",
            "account_claim": "Certificado de titularidad bancaria",
            "account": "IBAN",
            "balance_claim": "Certificado de saldo",
            "balance": "saldo",
            "date": "fecha de saldo",
            "average_balance": "saldo medio últimos 12 meses",
            "data-types": {
                "account_claim": "Certificado de titularidad bancaria",
                "balance_claim": "Certificado de saldo"
            }
        }
    },
    "fields_order":
    {
        "account_claim":
        [
            "account",
            "name",
            "surname",
            "nif"
        ],
        "balance_claim":
        [
            "account",
            "balance",
            "date",
            "average_balance",
            "name",
            "surname",
            "nif"
        ]
    }
}