_agnia.providers['double-opt-in'] =
{
    'name': 'double-opt-in',
    'did': 'did:agnia:EABC9D3208E82203170B248e1A14BF85F290AD7f',
    'logo': 'assets/img/checked-logo.png',
    'claims':
    [
        {
            'name': 'mail_code',
            'claim': 'mail',
            'form':
            {
                'url': baseUrl + 'providers/double-opt-in/mail_code/init',
                'fields':
                [
                    {
                        'label': 'Email',
                        'type': 'email',
                        'name': 'email',
                        'mandatory': true,
                        'validator': 'EMAIL'
                    }
                ]
            }
        },
        {
            'name': 'phonenumber_code',
            'claim': 'phonenumber',
            'form':
            {
                'url': baseUrl + 'providers/double-opt-in/phone_code/init',
                'fields':
                [
                    {
                        'label': 'Phonenumber',
                        'type': 'phonenumber',
                        'name': 'phonenumber',
                        'mandatory': true,
                        'validator': 'PHONENUMBER'
                    }
                ]
            }
        }
    ],
    'description_field':
    {
        'email': 'email',
        'phonenumber': 'phonenumber'
    },
    'i18n':
    {
        'en':
        {
            'double-opt-in': 'Double opt-in',
            'mail_code': 'Email with code',
            'Email': 'Email',
            'code_by_mail': 'Code (sent by email)',
            'code_by_sms': 'Code (sent by SMS)',
            'phonenumber_code': 'Phone with code',
            'Phonenumber': 'Phone',
            'data-types': {
                'email': 'E-mail',
                'phonenumber': 'Phone number'
            }
        },
        'es':
        {
            'double-opt-in': 'Doble opt-in',
            'mail_code': 'Correo electrónico con código',
            'Email': 'Correo electrónico',
            'code_by_mail': 'Código (que has recibido por email)',
            'code_by_sms': 'Código (que has recibido por SMS)',
            'phonenumber_code': 'Teléfono con código',
            'Phonenumber': 'Teléfono',
            'data-types': {
                'email': 'Correo electrónico',
                'phonenumber': 'Número de teléfono',
            }
        }
    }
};